#include <SPI.h>
#include <MFRC522.h>
#include<LiquidCrystal.h>

 
#define SS_PIN 10
#define RST_PIN 9
#define RED_LIGHT A1
#define GREEN_LIGHT A2
#define SERVO A3
#define BUZZER A4
#define IRQ 7

MFRC522 mfrc522(SS_PIN, RST_PIN);   // Create MFRC522 instance.
byte regVal = 0x7F;
void activateRec(MFRC522 mfrc522);
void clearInt(MFRC522 mfrc522);
volatile bool bNewInt = false;

LiquidCrystal lcd(8, 6, 5, 4, 3, 2); // Create lcd instance.

#define NOTE_B0 31  
 #define NOTE_C1 33  
 #define NOTE_CS1 35  
 #define NOTE_D1 37  
 #define NOTE_DS1 39  
 #define NOTE_E1 41  
 #define NOTE_F1 44  
 #define NOTE_FS1 46  
 #define NOTE_G1 49  
 #define NOTE_GS1 52  
 #define NOTE_A1 55  
 #define NOTE_AS1 58  
 #define NOTE_B1 62  
 #define NOTE_C2 65  
 #define NOTE_CS2 69  
 #define NOTE_D2 73  
 #define NOTE_DS2 78  
 #define NOTE_E2 82  
 #define NOTE_F2 87  
 #define NOTE_FS2 93  
 #define NOTE_G2 98  
 #define NOTE_GS2 104  
 #define NOTE_A2 110  
 #define NOTE_AS2 117  
 #define NOTE_B2 123  
 #define NOTE_C3 131  
 #define NOTE_CS3 139  
 #define NOTE_D3 147  
 #define NOTE_DS3 156  
 #define NOTE_E3 165  
 #define NOTE_F3 175  
 #define NOTE_FS3 185  
 #define NOTE_G3 196  
 #define NOTE_GS3 208  
 #define NOTE_A3 220  
 #define NOTE_AS3 233  
 #define NOTE_B3 247  
 #define NOTE_C4 262  
 #define NOTE_CS4 277  
 #define NOTE_D4 294  
 #define NOTE_DS4 311  
 #define NOTE_E4 330  
 #define NOTE_F4 349  
 #define NOTE_FS4 370  
 #define NOTE_G4 392  
 #define NOTE_GS4 415  
 #define NOTE_A4 440  
 #define NOTE_AS4 466  
 #define NOTE_B4 494  
 #define NOTE_C5 523  
 #define NOTE_CS5 554  
 #define NOTE_D5 587  
 #define NOTE_DS5 622  
 #define NOTE_E5 659  
 #define NOTE_F5 698  
 #define NOTE_FS5 740  
 #define NOTE_G5 784  
 #define NOTE_GS5 831  
 #define NOTE_A5 880  
 #define NOTE_AS5 932  
 #define NOTE_B5 988  
 #define NOTE_C6 1047  
 #define NOTE_CS6 1109  
 #define NOTE_D6 1175  
 #define NOTE_DS6 1245  
 #define NOTE_E6 1319  
 #define NOTE_F6 1397  
 #define NOTE_FS6 1480  
 #define NOTE_G6 1568  
 #define NOTE_GS6 1661  
 #define NOTE_A6 1760  
 #define NOTE_AS6 1865  
 #define NOTE_B6 1976  
 #define NOTE_C7 2093  
 #define NOTE_CS7 2217  
 #define NOTE_D7 2349  
 #define NOTE_DS7 2489  
 #define NOTE_E7 2637  
 #define NOTE_F7 2794  
 #define NOTE_FS7 2960  
 #define NOTE_G7 3136  
 #define NOTE_GS7 3322  
 #define NOTE_A7 3520  
 #define NOTE_AS7 3729  
 #define NOTE_B7 3951  
 #define NOTE_C8 4186  
 #define NOTE_CS8 4435  
 #define NOTE_D8 4699  
 #define NOTE_DS8 4978  
 #define REST 0  
 // change tempo to make the song slower or faster  
int tempo1 = 85;  
int tempo2 = 108;
int tempo3 = 144;

 // change this to whichever pin you want to use  
 int buzzer = 11;  
 // notes of the moledy followed by the duration.  
 // a 4 means a quarter note, 8 an eighteenth , 16 sixteenth, so on  
 // !!negative numbers are used to represent dotted notes,  
 // so -4 means a dotted quarter note, that is, a quarter plus an eighteenth!!  
 int melody1[] = {
  
    // Game of Thrones
    // Score available at https://musescore.com/user/8407786/scores/2156716
  
    NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16, NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16, //1
    NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16, NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16,
    NOTE_G4,8, NOTE_C4,8, NOTE_E4,16, NOTE_F4,16, NOTE_G4,8, NOTE_C4,8, NOTE_E4,16, NOTE_F4,16,
    NOTE_G4,8, NOTE_C4,8, NOTE_E4,16, NOTE_F4,16, NOTE_G4,8, NOTE_C4,8, NOTE_E4,16, NOTE_F4,16,
    NOTE_G4,-4, NOTE_C4,-4,//5
  
    NOTE_DS4,16, NOTE_F4,16, NOTE_G4,4, NOTE_C4,4, NOTE_DS4,16, NOTE_F4,16, //6
    NOTE_D4,-1, //7 and 8
    NOTE_F4,-4, NOTE_AS3,-4,
    NOTE_DS4,16, NOTE_D4,16, NOTE_F4,4, NOTE_AS3,-4,
    NOTE_DS4,16, NOTE_D4,16, NOTE_C4,-1, //11 and 12
  
    //repeats from 5
    NOTE_G4,-4, NOTE_C4,-4,//5
  
    NOTE_DS4,16, NOTE_F4,16, NOTE_G4,4, NOTE_C4,4, NOTE_DS4,16, NOTE_F4,16, //6
    NOTE_D4,-1, //7 and 8
    NOTE_F4,-4, NOTE_AS3,-4,
    NOTE_DS4,16, NOTE_D4,16, NOTE_F4,4, NOTE_AS3,-4,
    NOTE_DS4,16, NOTE_D4,16, NOTE_C4,-1, //11 and 12
    NOTE_G4,-4, NOTE_C4,-4,
    NOTE_DS4,16, NOTE_F4,16, NOTE_G4,4,  NOTE_C4,4, NOTE_DS4,16, NOTE_F4,16,
  
    NOTE_D4,-2,//15
    NOTE_F4,-4, NOTE_AS3,-4,
    NOTE_D4,-8, NOTE_DS4,-8, NOTE_D4,-8, NOTE_AS3,-8,
    NOTE_C4,-1,
    NOTE_C5,-2,
    NOTE_AS4,-2,
    NOTE_C4,-2,
    NOTE_G4,-2,
    NOTE_DS4,-2,
    NOTE_DS4,-4, NOTE_F4,-4, 
    NOTE_G4,-1,
    
    NOTE_C5,-2,//28
    NOTE_AS4,-2,
    NOTE_C4,-2,
    NOTE_G4,-2, 
    NOTE_DS4,-2,
    NOTE_DS4,-4, NOTE_D4,-4,
    NOTE_C5,8, NOTE_G4,8, NOTE_GS4,16, NOTE_AS4,16, NOTE_C5,8, NOTE_G4,8, NOTE_GS4,16, NOTE_AS4,16,
    NOTE_C5,8, NOTE_G4,8, NOTE_GS4,16, NOTE_AS4,16, NOTE_C5,8, NOTE_G4,8, NOTE_GS4,16, NOTE_AS4,16,
    
    REST,4, NOTE_GS5,16, NOTE_AS5,16, NOTE_C6,8, NOTE_G5,8, NOTE_GS5,16, NOTE_AS5,16,
    NOTE_C6,8, NOTE_G5,16, NOTE_GS5,16, NOTE_AS5,16, NOTE_C6,8, NOTE_G5,8, NOTE_GS5,16, NOTE_AS5,16,  
  };
  
  // sizeof gives the number of bytes, each int value is composed of two bytes (16 bits)
  // there are two values per note (pitch and duration), so for each note there are four bytes
  int notes1 = sizeof(melody1) / sizeof(melody1[0]) / 2;
  
  // this calculates the duration of a whole note in ms
  int wholenote1 = (60000 * 4) / tempo1; 

 int melody2[] = {  
   // Dart Vader theme (Imperial March) - Star wars 
  // Score available at https://musescore.com/user/202909/scores/1141521
  // The tenor saxophone part was used
  
  NOTE_AS4,8, NOTE_AS4,8, NOTE_AS4,8,//1
  NOTE_F5,2, NOTE_C6,2,
  NOTE_AS5,8, NOTE_A5,8, NOTE_G5,8, NOTE_F6,2, NOTE_C6,4,  
  NOTE_AS5,8, NOTE_A5,8, NOTE_G5,8, NOTE_F6,2, NOTE_C6,4,  
  NOTE_AS5,8, NOTE_A5,8, NOTE_AS5,8, NOTE_G5,2, NOTE_C5,8, NOTE_C5,8, NOTE_C5,8,
  NOTE_F5,2, NOTE_C6,2,
  NOTE_AS5,8, NOTE_A5,8, NOTE_G5,8, NOTE_F6,2, NOTE_C6,4,  
  
  NOTE_AS5,8, NOTE_A5,8, NOTE_G5,8, NOTE_F6,2, NOTE_C6,4, //8  
  NOTE_AS5,8, NOTE_A5,8, NOTE_AS5,8, NOTE_G5,2, NOTE_C5,-8, NOTE_C5,16, 
  NOTE_D5,-4, NOTE_D5,8, NOTE_AS5,8, NOTE_A5,8, NOTE_G5,8, NOTE_F5,8,
  NOTE_F5,8, NOTE_G5,8, NOTE_A5,8, NOTE_G5,4, NOTE_D5,8, NOTE_E5,4,NOTE_C5,-8, NOTE_C5,16,
  NOTE_D5,-4, NOTE_D5,8, NOTE_AS5,8, NOTE_A5,8, NOTE_G5,8, NOTE_F5,8,
  
  NOTE_C6,-8, NOTE_G5,16, NOTE_G5,2, REST,8, NOTE_C5,8,//13
  NOTE_D5,-4, NOTE_D5,8, NOTE_AS5,8, NOTE_A5,8, NOTE_G5,8, NOTE_F5,8,
  NOTE_F5,8, NOTE_G5,8, NOTE_A5,8, NOTE_G5,4, NOTE_D5,8, NOTE_E5,4,NOTE_C6,-8, NOTE_C6,16,
  NOTE_F6,4, NOTE_DS6,8, NOTE_CS6,4, NOTE_C6,8, NOTE_AS5,4, NOTE_GS5,8, NOTE_G5,4, NOTE_F5,8,
  NOTE_C6,1
 };

 // sizeof gives the number of bytes, each int value is composed of two bytes (16 bits)  
 // there are two values per note (pitch and duration), so for each note there are four bytes  
 int notes2 = sizeof(melody2) / sizeof(melody2[0]) / 2;  
 // this calculates the duration of a whole note in ms  
 int wholenote2 = (60000 * 4) / tempo2;


 int melody3[] = {


  // Hedwig's theme fromn the Harry Potter Movies
  // Socre from https://musescore.com/user/3811306/scores/4906610
  
  REST, 2, NOTE_D4, 4,
  NOTE_G4, -4, NOTE_AS4, 8, NOTE_A4, 4,
  NOTE_G4, 2, NOTE_D5, 4,
  NOTE_C5, -2, 
  NOTE_A4, -2,
  NOTE_G4, -4, NOTE_AS4, 8, NOTE_A4, 4,
  NOTE_F4, 2, NOTE_GS4, 4,
  NOTE_D4, -1, 
  NOTE_D4, 4,

  NOTE_G4, -4, NOTE_AS4, 8, NOTE_A4, 4, //10
  NOTE_G4, 2, NOTE_D5, 4,
  NOTE_F5, 2, NOTE_E5, 4,
  NOTE_DS5, 2, NOTE_B4, 4,
  NOTE_DS5, -4, NOTE_D5, 8, NOTE_CS5, 4,
  NOTE_CS4, 2, NOTE_B4, 4,
  NOTE_G4, -1,
  NOTE_AS4, 4,
     
  NOTE_D5, 2, NOTE_AS4, 4,//18
  NOTE_D5, 2, NOTE_AS4, 4,
  NOTE_DS5, 2, NOTE_D5, 4,
  NOTE_CS5, 2, NOTE_A4, 4,
  NOTE_AS4, -4, NOTE_D5, 8, NOTE_CS5, 4,
  NOTE_CS4, 2, NOTE_D4, 4,
  NOTE_D5, -1, 
  REST,4, NOTE_AS4,4,  

  NOTE_D5, 2, NOTE_AS4, 4,//26
  NOTE_D5, 2, NOTE_AS4, 4,
  NOTE_F5, 2, NOTE_E5, 4,
  NOTE_DS5, 2, NOTE_B4, 4,
  NOTE_DS5, -4, NOTE_D5, 8, NOTE_CS5, 4,
  NOTE_CS4, 2, NOTE_AS4, 4,
  NOTE_G4, -1, 
  
};

  int notes3 = sizeof(melody3) / sizeof(melody3[0]) / 2;
  
  // this calculates the duration of a whole note in ms (60s/tempo)*4 beats
  int wholenote3 = (60000 * 4) / tempo3;
 int divider = 0, noteDuration = 0;
 int currentNote = 0;


void setup() 
{
  Serial.begin(9600);   // Initiate a serial communication
  SPI.begin();      // Initiate  SPI bus
  mfrc522.PCD_Init();   // Initiate MFRC522
  regVal = 0xA0; //rx irq
  mfrc522.PCD_WriteRegister(mfrc522.ComIEnReg, regVal);
  pinMode(IRQ, INPUT_PULLUP);
  
  Serial.println("Approximate your card to the reader...");
  Serial.println();
  pinMode(RED_LIGHT, OUTPUT);
  pinMode(GREEN_LIGHT, OUTPUT);
  pinMode(SERVO, OUTPUT);
  pinMode(BUZZER, OUTPUT);
  
  servo.attach(SERVO);
  servo.write(90);
  lcd.begin(16, 2); 

}

String titles[] = {
  "Game of Thrones    ",
  "Star Wars          ",
  "Harry Potter       "
};


int currentSong = 0;

int checkIfCardPresented() 
{
  if ( ! mfrc522.PICC_IsNewCardPresent()) 
  {
    return 0;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial()) 
  {
    return 0;
  }
  //Show UID on serial monitor
  Serial.print("UID tag :");
  String content= "";
  byte letter;
  //Converting the response from de RFID reader to HEX
  for (byte i = 0; i < mfrc522.uid.size; i++) 
  {
     Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     Serial.print(mfrc522.uid.uidByte[i], HEX);
     content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  Serial.println();
  Serial.print("Message : ");
  content.toUpperCase();
  
  //Checking if the tag detected has the proper UID
  if (content.substring(1) == "67 9B 25 B3") 
  {
    Serial.println("Authorized access");
    lcd.setCursor(0,0);          
    lcd.print("     Next        ");
    lcd.setCursor(0,1);           
    lcd.print("     Song        ");    
    analogWrite(GREEN_LIGHT, 255);
    Serial.println();
    //The buzzer makes the "granted sound" for 500ms
    tone(BUZZER, 1000);
   
    delay(500);
    noTone(BUZZER);
    delay(2000);
    servo.write(90);
    analogWrite(GREEN_LIGHT, 0);
    return 1;
  } else {
    analogWrite(RED_LIGHT, 255);
    lcd.setCursor(0,0);          
    lcd.print("     Previous     ");
    lcd.setCursor(0,1);           
    lcd.print("     Song     "); 
    //The buzzer makes the "denied sound" for 500 ms
    tone(BUZZER, 800);
    delay(500);
    noTone(BUZZER);
    delay(2000);
    analogWrite(RED_LIGHT, 0);
    return 2;
  }
}


void playMelody(int *melody, int notes, int wholenote, String titles[], int titleIndex, int songNum) {
    lcd.setCursor(0,0);          
    lcd.print(titles[titleIndex]); 
   if(currentNote < notes * 2) {
      
   }
   for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {  
       // calculates the duration of each note
      int cardPresented = checkIfCardPresented();
      if(cardPresented == 1) {
        currentSong = (currentSong + 1) % songNum;
        return;
      }

      if(cardPresented == 2) {
        if(currentSong - 1 >= 0)
          currentSong = currentSong - 1;
        return;
      }
      
      divider = melody[thisNote + 1];  
      if (divider > 0) {  
      // regular note, just proceed  
      noteDuration = (wholenote) / divider;  
      } else if (divider < 0) {  
      // dotted notes are represented with negative durations!!  
      noteDuration = (wholenote) / abs(divider);  
      noteDuration *= 1.5; // increases the duration in half for dotted notes  
     }  
      // we only play the note for 90% of the duration, leaving 10% as a pause  
      tone(BUZZER, melody[thisNote], noteDuration * 0.9);  
      // Wait for the specief duration before playing the next note.  
      delay(noteDuration);  
      // stop the waveform generation before the next note.  
      noTone(BUZZER);
    }
}

void loop() 
{
  lcd.setCursor(0,0);          
  lcd.print("Scan to        "); 
  lcd.setCursor(1,1);           
  lcd.print("Play           ");    
  //playMelody(melody1, notes1, wholenote1);
  if(currentSong == 0 && checkIfCardPresented() == 1) {
    currentSong = currentSong + 1;
  }
  switch(currentSong) {
    case 0:
      break;
    case 1:
      playMelody(melody1, notes1, wholenote1, titles, 0, 4);
    case 2:
      playMelody(melody2, notes2, wholenote2, titles, 1, 4);
    case 3:
      playMelody(melody3, notes3, wholenote3, titles, 2, 4);
    default:
      break;
  }
}

/*
 * The function sending to the MFRC522 the needed commands to activate the reception
 */
void activateRec(MFRC522 mfrc522) {
  mfrc522.PCD_WriteRegister(mfrc522.FIFODataReg, mfrc522.PICC_CMD_REQA);
  mfrc522.PCD_WriteRegister(mfrc522.CommandReg, mfrc522.PCD_Transceive);
  mfrc522.PCD_WriteRegister(mfrc522.BitFramingReg, 0x87);
}

/*
 * The function to clear the pending interrupt bits after interrupt serving routine
 */
void clearInt(MFRC522 mfrc522) {
  mfrc522.PCD_WriteRegister(mfrc522.ComIrqReg, 0x7F);
}

//Card UID: 679B25B3
